<?php
/**
 * @file Contains
 *   \Drupal\tint_connector\Plugin\Field\FieldFormatter\TintFormatter.
 */

namespace Drupal\tint_connector\Plugin\Field\FieldFormatter;

use Drupal;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;

/**
 * Plugin implementation of the 'field_tint' formatter.
 *
 * @FieldFormatter(
 *   id = "tint_connector_formatter",
 *   module = "tint_connector",
 *   label = @Translation("Tint Integration widget formatter"),
 *   field_types = {
 *     "field_tint"
 *   }
 * )
 */
class TintFormatter extends FormatterBase {
  
  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $element = [];
    foreach ($items as $delta => $item) {
      $configSettings = Drupal::config('tint_connector.settings');
      // Render each element as markup.
      $element[$delta] = [
        '#theme' => 'tint-widget',
        '#data_id' => $configSettings->get('data_id'),
        '#personalization_id' => $configSettings->get('personalization_id'),
        '#data_expand' => $configSettings->get('data_expand'),
        '#data_infinitescroll' => $configSettings->get('data_infinitescroll'),
        '#columns' => $configSettings->get('columns'),
        '#clickformore' => $configSettings->get('clickformore'),
        '#attached' => [
          'library' => [
            'tint_connector/tint-library',
          ],
        ],
      ];
    }
    
    return $element;
    
  }
  
}
